
/* nbody.c */

#include <stdio.h>
#include <stdlib.h>

#define DEFAULT_STRING_LENGTH  1023

static const int    default_string_length = DEFAULT_STRING_LENGTH;
static char         base_filename[DEFAULT_STRING_LENGTH+1];
static float        domain_size_x;
static float        domain_size_y;
static float        domain_size_z;
static float        time_interval;
static int          number_of_particles;
static int          number_of_timesteps;
static int          timesteps_between_outputs;
static unsigned int random_seed;

#include "nbody_particle_star.h"
#include "nbody_particle_star.c"

int main (int argc, char** argv)
{ /* main */
    Particle* particle_array = (Particle*)NULL;
    int       timestep;

    Particle_input_arguments();

    particle_array = Particle_array_construct(number_of_particles);

    Particle_array_initialize(particle_array, number_of_particles);

    Particle_array_output(base_filename,
        particle_array, number_of_particles, 0);

    for (timestep = 1; timestep <= number_of_timesteps; timestep++) {

        fprintf(stderr, "Starting timestep #%d.\n", timestep);

        Particle_array_calculate_forces(particle_array, number_of_particles);

        Particle_array_move(particle_array, number_of_particles,
            time_interval);

        if ((timestep % timesteps_between_outputs) == 0) {

            Particle_array_output(base_filename,
                particle_array, number_of_particles, timestep);

        } /* if ((timestep % timesteps_between_outputs) == 0) */

    } /* for timestep */

    if ((number_of_timesteps % timesteps_between_outputs) != 0) {

        Particle_array_output(base_filename,
            particle_array, number_of_particles, number_of_timesteps);

    } /* if ((number_of_timesteps % timesteps_between_outputs) != 0) */

    particle_array =
        Particle_array_destruct(particle_array, number_of_particles);

    return program_success_code;

} /* main */

