!!!!!!!!!!!!!!!
!! nbody.f90 !!
!!!!!!!!!!!!!!!

      PROGRAM nbody

          USE nbody_particle_star

          IMPLICIT NONE

          INTEGER :: timestep

          CALL Particle_input_arguments()

          CALL Particle_array_construct()

          CALL Particle_array_initialize()

          CALL Particle_array_output(base_filename, 0)

          DO timestep = 1, number_of_timesteps

              IF (debug) THEN

                  WRITE (0,*) "Starting timestep #", timestep, "."

              END IF !! (debug)

              CALL Particle_array_calculate_forces()

              CALL Particle_array_move()

              IF (MOD(timestep, timesteps_between_outputs) == 0) THEN

                  CALL Particle_array_output(base_filename, timestep)

              END IF !! (MOD(timestep, timesteps_between_outputs) == 0)

              IF (debug) THEN

                  WRITE (0,*) "Ending timestep #", timestep, "."

              END IF !! (debug)

          END DO !! timestep

          IF (MOD(number_of_timesteps,  &
     &            timesteps_between_outputs) /= 0) THEN

              CALL Particle_array_output(base_filename,  &
     &                                   number_of_timesteps)

          END IF !! (MOD(timestep, timesteps_between_outputs) /= 0)

          CALL Particle_array_destroy()

      END PROGRAM nbody

